%define myname gosa
%define rpmrelease gonicus.1
# GOsaVersion can be defined externally
# do rpmbuild --rebuild --define 'GOsaVersion 2.0' gosa..srpm
%{!?GOsaVersion:%define GOsaVersion 2.0rc1}
# Detect SuSE, else its RedtHat
%{?suse_version:%define suse 1}
%{!?suse_version:%define suse 0}
Summary: Web Based LDAP Administration Program 
Name: %{myname}
Version: %{GOsaVersion} 
Release: %{rpmrelease}
License: GPL
Vendor: GONICUS GmbH
Packager: Lars Scheiter <scheiter@GONICUS.de>
Group: System/Administration
Buildarch: noarch
Source: ftp://oss.GONICUS.de/pub/gosa/%{name}.tar.bz2
URL: http://www.GONICUS.de
%if %{suse}
Prereq: php4
%else
Prereq: php
%endif
Prefix: /usr/share/gosa
BuildRoot: %{_tmppath}/%{name}-%{version}-root
%define confdir /etc/%{myname}

%description
GOsa is a combination of system-administrator and end-user web
interface, designed to handle LDAP based setups.
Provided is access to posix, shadow, samba, proxy, fax, and kerberos
accounts. It is able to manage the postfix/cyrus server combination
and can write user adapted sieve scripts.

%prep
%setup -q -n %{name}

%build
%if %{suse}
	echo "Building SUSE RPM"
	%define wwwuser wwwrun 
%else
	echo "Building RedHat RPM"
	%define wwwuser apache
%endif

%install
# Create buildroot
mkdir -p %{buildroot}/%{prefix}
for i in `ls | grep -v debian | grep -v CVS`; do \
          cp -R $i %{buildroot}/%{prefix} ; \
done
mkdir -p %{buildroot}/var/spool/gosa
# Copy default config
mkdir -p %{buildroot}/%{confdir}
cp %{buildroot}/%{prefix}/contrib/gosa.conf %{buildroot}/%{confdir}/
# Cleanup docs
cat > %{buildroot}/%{confdir}/gosa_include.conf <<EOF
# Set alias to gosa
Alias /gosa /usr/share/gosa/html
EOF
chown %{wwwuser}.root %{buildroot}/%{confdir}/*
chmod o-rwx %{buildroot}/%{confdir}/*
for i in AUTHORS COPYING Changelog INSTALL README TODO contrib doc doxygen.conf; do
	rm -rf %{buildroot}/%{prefix}/$i
done 

%pre
cat <<EOF
Starting to install GOsa package, please wait.

                            NO WARRANTY

BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.


EOF

%if %{suse}
%post
if [ -e /etc/httpd/httpd.conf ]; then
	echo "Configuring Apache"
	grep gosa_include.conf /etc/httpd/httpd.conf &>/dev/null
	if [ $? -eq 0 ]; then
		echo "Apache already configured"
	else
		echo "Adding GOsa configuration"
		echo "Include /etc/gosa/gosa_include.conf" >> /etc/httpd/httpd.conf
		APACHERESTART="yes"
		/etc/init.d/apache restart
	fi
fi
if [ -e /etc/apache2/httpd.conf ]; then
	echo "Configuring Apache2"
	grep gosa_include.conf /etc/apache2/httpd.conf &>/dev/null
	if [ $? -eq 0 ]; then
		echo "Apache already configured"
	else
		echo "Adding GOsa configuration"
		echo "Include /etc/gosa/gosa_include.conf" >> /etc/apache2/httpd.conf
		if [ -z $APACHERESTART ]; then
			/etc/init.d/apache2 restart
		else
			echo "Found another apache installation, NOT restarting apache2"
		fi
	fi
fi
%else
%post
if [ -e /etc/httpd/conf/httpd.conf ]; then
	echo "Configuring Apache"
	grep gosa_include.conf /etc/httpd/conf/httpd.conf &>/dev/null
	if [ $? -eq 0 ]; then
		echo "Apache already configured"
	else
		echo "Adding GOsa configuration"
		echo "Include /etc/gosa/gosa_include.conf" >> /etc/httpd/conf/httpd.conf
		/etc/init.d/httpd restart
	fi
fi
%endif

%if %{suse}
%preun
if [ -e /etc/httpd/httpd.conf ]; then
	grep -v gosa_include.conf /etc/httpd/httpd.conf >/tmp/apache.tmp
	mv -f /tmp/apache.tmp /etc/httpd/httpd.conf
	APACHERESTART="yes"
	/etc/init.d/apache restart
fi
if [ -e /etc/apache2/httpd.conf ]; then
	grep -v gosa_include.conf /etc/apache2/httpd.conf >/tmp/apache.tmp
	mv -f /tmp/apache.tmp /etc/apache2/httpd.conf
	if [ -z $APACHERESTART ]; then
		/etc/init.d/apache2 restart
	else
		echo "Found another apache installation, NOT restarting apache2"
	fi
fi
echo "Please verify your Apache configuration!!"
%else
%preun
if [ -e /etc/httpd/conf/httpd.conf ]; then
	grep -v gosa_include.conf /etc/httpd/conf/httpd.conf >/tmp/apache.tmp
	mv -f /tmp/apache.tmp /etc/httpd/conf/httpd.conf
	/etc/init.d/httpd restart
fi
echo "Please verify your Apache configuration!!"
%endif

%clean
rm -rf %{buildroot}
rm -rf %{_builddir}/%{buildsubdir}

%files
%defattr(0750,%{wwwuser},root)
%config %{confdir}/gosa.conf
%config %{confdir}/gosa_include.conf
%defattr(0750,%{wwwuser},root)
%{prefix}
%dir /var/spool/gosa
%doc AUTHORS TODO README Changelog COPYING INSTALL contrib doc

%changelog
* Mon Oct 20 2003 Lars Scheiter <lars.scheiter@GONICUS.de>
- Update to new upstream release (2.0rc1)
* Fri Oct 17 2003 Lars Scheiter <lars.scheiter@GONICUS.de>
- First build of GOsa as an RPM, should work on SuSE and RedHat
