<?php

function check($text, $choose, $ignore= 0)
{
  echo "$text: ";
  if ($choose){
    echo "OK<br>";
  } else {
    if ($ignore){
      echo "<font color=red>Ignored</font><br>";
      return (0);
    } else {
      echo "<font color=red>Failed</font><br>";
    }
  }

  return $choose;
}

function check_download($buffer)
{
  global $check_download_ok;

  if (preg_match ('/^http\/[^\s]+\s+200/i', $buffer)){
    $check_download_ok= 1;
  }
}
     

function perform_checks()
{
  global $check_globals;
  $error= 0;

  ##
  ## Webserver dependencies
  ##
 
  # Check for PHP Version
  # >= 4.1
  echo "<h1>PHP setup inspection</h1>";
  check ("Checking for PHP version (>=4.1.0)", minimum_version('4.1.0')) || $error++;
  check ("Checking if register_globals is off", $check_globals == 0) || $error++;
  check ("Checking for module ldap", function_exists('ldap_bind')) || $error++;
  check ("Checking for module mhash (only needed for SSHA encryption)", function_exists('mhash'), 1) || $error++;
  check ("Checking for module curl", function_exists('curl_init')) || $error++;
  check ("Checking for module gd", function_exists('imagecreate')) || $error++;
  check ("Checking for module imap", function_exists('imap_open')) || $error++;
  check ("Checking for getacl in imap (only needed for shared folder support)", function_exists('imap_getacl'), 1) || $error++;
  check ("Checking for module mysql (only needed for GOfax support)", function_exists('mysql_query'), 1) || $error++;
  check ("Checking for module cups (only needed for choosing default printers)", function_exists('cups_get_dest_list'),1) || $error++;
  check ("Checking for module kadm5 (only needed for kerberos management)", function_exists('kadm5_init_with_password'),1) || $error++;
  
  if ($error == 0){
    # Security check
    echo "<h1>Webserver setup inspection</h1>";
    
    # try to download functions.inc
    $file= $HTTP_SERVER_VARS['HTTP_HOST'].preg_replace("/setup.php$/", "include/functions.inc", $HTTP_SERVER_VARS['PHP_SELF']);
    $check_download_ok= 0;
    $ch = curl_init();
  
    curl_setopt ($ch, CURLOPT_URL, "$file");
    curl_setopt ($ch, CURLOPT_HEADER, 1 );
    curl_setopt ($ch, CURLOPT_NOBODY, 1 );
    curl_setopt ($ch, CURLOPT_FAILONERROR, 0 );
  
    ob_start("check_download");
    curl_exec ($ch);
  
    curl_close ($ch); 
    ob_end_flush();
    check ("Checking if *.inc download is disabled", $check_download_ok == 0) || $error++;

    check ("Currently running via SSL (required for setup)", stristr($HTTP_SERVER_VARS['HTTPS'], "on"), 1);# || $error++;


    # Programm check
    echo "<h1>Checking for some additional programms</h1>";
  
    # Image Magick
    $query= "LC_ALL=C LANG=C convert -help";
    $output= shell_exec ($query);
    $lines= split ("\n", $output);
    $version= preg_replace ("/^Version:[^I]+ImageMagick ([^\s]+).*/", "\\1", $lines[0]);
    list($major, $minor)= split("\.", $version);
    check ("Checking for ImageMagick (>=5.4.0)", ($major > 5 || ($major == 5 && $minor >= 4)));
    
    # Check for fping
    $query= "LC_ALL=C LANG=C fping -v 2>&1";
    $output= shell_exec ($query);
    $have_fping= preg_match("/^fping:/", $output);
    check ("Checking for fping utility", $have_fping) || $error++;

    # Check for smb hash generation tool
    $query= "mkntpwd 2>&1";
    $output= shell_exec ($query);
    $have_mkntpwd= preg_match("/^Usage: mkntpwd /", $output);
    check ("Checking for mkntpwd utility", $have_mkntpwd, 1);
  
    if (!$have_mkntpwd){
      $query= "LC_ALL=C LANG=C perl -MCrypt::SmbHash -e 'ntlmgen \"PASSWD\", \$lm, \$nt; print \"\${lm}:\${nt}\\n\";' &>/dev/null";
      system ($query, $ret);
      check ("Trying alternative perl mkntpwd routine", $ret == 0) || $error++;
    }
  }

  return $error;
}



  # Logfile
  # Warn apache != ssl
  # Default language
  # Performance indicator


  ##
  ## Site specific setup
  ##
  
  # Form for GOsa gosa.conf
  # -> Default Site
  # -> Editor for Sites
  # -> Check Site for presence of schemata and LDAP base configuration
  # -> Posibility to create LDAP base configuration via formular
  # -> check imap and sieve functionality
