<?php

class phonelist extends plugin
{
  /* Phonelist attributes */
  var $telephone_list = array();
  var $start= 0;
  var $search_for= "*";
  var $search_base= "";
  var $search_type= "";

  /* attribute list for save action */
  var $attributes= array();
  var $objectclasses= array();

  function phonelist ($config, $dn= NULL)
  {
	/* Include config object */
	$this->config= $config;

	/* Try to get matching search base for user provided
	   by 'dn' */
	$tmp= preg_replace ("/^[^,]+,[^,]+,/", "", $dn);
	$sb= array_search($tmp, $this->config->departments);
	if ($sb === FALSE){
		$sb= "/";
	}
	$this->search_base= $sb;
  }

  function execute()
  {

	/* Check for interaction */
	if ($_SERVER["REQUEST_METHOD"] == "POST"){

		/* Save formular information */
		$this->save_objects();

		/* User want's to search */
		if (isset($_POST['search']) && $_POST['search_for'] != ""){
			if ($_POST['search_type'] == "fuzzy"){
				if (is_integer (strpos($_POST['search_for'], "*"))){
					$s= $_POST['search_for'];
				} else {
					$s= "*".$_POST['search_for']."*";
				}
			} else {
				$s= $_POST['search_for'];
			}
		} else {
			$s= "*";
		}

		/* Make search work on localized character sets */
		$s= utf8_encode($s);

		/* Get ldap link / build filter */
		$ldap= $this->config->get_ldap_link();
		$ldap->cd ($this->config->departments[$this->search_base]);
		$ldap->search ("(&(objectClass=gosaAccount)(!(objectClass=gosaUserTemplate))".
			"(|(uid=$s)(l=$s)(homePhone=$s)(telephoneNumber=$s)".
			"(facsimileTelephoneNumber=$s)(mobile=$s)(pager=$s)(cn=$s)".
			"(givenName=$s)(sn=$s)(personalTitle=$s)(title=$s)(mail=$s)))");

		/* Build current list, error reporting is off, because many of the
		   objects may not be defined after LDAP queries. Asking for presence
		   first is too much overhead. */
		error_reporting(0);
		$this->telephone_list= array ();

		/* Walk through LDAP results */
		while ($attrs= $ldap->fetch()){

			/* Only show lines that have set any mail or phone informations */
			if (isset($attrs['telephoneNumber'][0]) ||
				isset($attrs['facsimileTelephoneNumber'][0]) ||
				isset($attrs['mobile'][0]) ||
				isset($attrs['homePhone'][0]) ||
				isset($attrs['mail'][0])){

				$this->telephone_list[$attrs['cn'][0]]=
					"<td>".utf8_decode($attrs['cn'][0])."</td>".
					"<td>".utf8_decode($attrs['ou'][0])."</td>".
					"<td>".$attrs['telephoneNumber'][0]."</td>".
					"<td>".$attrs['facsimileTelephoneNumber'][0]."</td>".
					"<td>".$attrs['mobile'][0]."</td>".
					"<td>".$attrs['homePhone'][0]."</td>".
					"<td><a href=\"mailto: ".$attrs['mail'][0]."\">".
					$attrs['mail'][0]."</a></td>";
			}
		}
		error_reporting(E_ALL);

		/* Sort up list */
		ksort ($this->telephone_list);
		reset ($this->telephone_list);
	}

	/* Show main page */
	require ("edit.inc");
  }

  function save_objects()
  {
	$this->search_base= $_POST['search_base'];
	$this->search_type= $_POST['search_type'];
	$this->search_for=  $_POST['search_for'];
  }

}

?>
