<?php
class department extends plugin
{
  /* department attributes */
  var $ou= "";
  var $description= "";
  var $base= "";
  var $st= "";
  var $l= "";
  var $postalAddress= "";
  var $businessCategory= "";
  var $telephoneNumber= "";
  var $facsimileTelephoneNumber= "";

  /* Headpage attributes */
  var $last_dep_sorting= "invalid";
  var $departments= array();

  /* attribute list for save action */
  var $attributes= array("ou", "description", "businessCategory", "st", "l", "postalAddress",
			"telephoneNumber", "facsimileTelephoneNumber");
  var $objectclasses= array("gosaDepartment", "organizationalUnit");

  function department ($config, $ui)
  {
	$this->ui= $ui;
	$this->dn= "";
	$this->config= $config;
  }

  function execute()
  {
	/* Reload departments */
	$this->config->departments= get_departments();

	/* Create new department? */
	if (isset($_POST['new_department'])){
		$this->clear_fields();
		$this->acl= "#all#";
		$this->dn= "new";
		plugin::plugin ($this->config, $this->dn);
	}

	/* Edit existing department */
	if (isset($_POST['select_department']) && isset($_POST['deplist']) != ""){
		$this->clear_fields();
		$this->dn= $this->config->departments[$_POST['deplist']];
		$this->acl= get_permissions ($this->dn, $this->ui->subtreeACL);
		$this->acl= get_module_permission($this->acl, "department", $this->dn);
		plugin::plugin ($this->config, $this->dn);
		$this->base= $_POST['deplist'];
	}


	/* Delete requested department */
	if (isset($_POST['delete_department']) && isset($_POST['deplist'])){
		$this->dn= $this->config->departments[$_POST['deplist']];

		/* Check locking */
		if (($user= get_lock($this->dn)) != ""){
			$_SESSION['dn']= $this->dn;
			gen_locked_message($user, $this->dn);
			return;
		} else {
			# Lock this dn for editing
			add_lock ($this->dn, $this->ui->dn);

			@require_once ("remove.inc");
			return;
		}
	}


	/* What about finish? */
	if (isset($_POST['edit_finish'])){
		$message= $this->check();

		/* No errors, save object */
		if (count ($message) == 0){

			/* Perpare 'dn' in case of new entries */
			if ($this->dn == "new"){
				$this->dn= utf8_encode("ou=$this->ou,".$this->config->departments[$this->base]);
			}

			$this->save ();
			$this->clear_fields();
			del_lock ($this->ui->dn);
		} else {
			/* Errors found, show message */
			show_errors ($message);
		}
	}

	/* Finally delete department */
	if (isset($_POST['delete_department_confirm'])){
		$acl= get_permissions ($this->dn, $this->ui->subtreeACL);
		$acl= get_module_permission($acl, "department", $this->dn);
		if (chkacl($acl, "all") == ""){
			$this->remove_from_parent();
			$this->reload ();
		} else {
			print_red ("You have no permission to remove this department.");
		}
	}


	/* Cancel dialog */
	if (isset($_POST['edit_cancel']) || isset($_POST['delete_cancel']) ||
		isset($_POST['delete_department_confirm']) || isset($_POST['delete_lock'])){

		del_lock ($this->dn);
		$this->clear_fields();
	}


	/* Headpage or normal plugin screen? */
	if ($this->dn == ""){
		/* Check sorting variable */
		$this->check_sortranges();
		$this->reload();

		/* Show main page */
		require ("headpage.inc");
		return;
	}

	/* Show main page */
	require ("edit.inc");
  }

  function clear_fields()
  {
	$this->dn= "";
	$this->base= "";
	$this->acl= "#none#";

	foreach ($this->attributes as $val){
		$this->$val= "";
	}
  }

  function reload()
  {
	/*Get all gosaDepartments */
	$res= get_list($this->ui->subtreeACL, "(objectClass=gosaDepartment)");

	$this->departments= array();
	foreach ($res as $value){
		if (preg_match ($this->sortranges[$this->sorting], $value["ou"][0])){
			$title= utf8_decode (convert_department_dn($value["dn"]));
			$this->departments[$title]= "$title [".utf8_decode($value["description"][0])."]";
		}
	}
	natcasesort ($this->departments);
	reset ($this->departments);
  }

  function remove_from_parent()
  {
	$delarray= array();
	$ldap= $this->config->get_ldap_link();
	$ldap->cd ($this->dn);

	/* Get sorted list of dn's to delete */
	$ldap->search ("(objectClass=*)");
	while ($ldap->fetch()){
		$deldn= $ldap->getDN();
		$delarray[$deldn]= strlen($deldn);
	}
	arsort ($delarray);
	reset ($delarray);

	/* Delete all dn's in subtree */
	foreach ($delarray as $key => $value){
		$ldap->rmdir($key);
		if ($ldap->error != "Success"){
			printe ("department", $ldap->error);
		}
	}

	/* Optionally execute a command after we're done */
	$this->postremove();
  }


  /* Save data to object */
  function save_object()
  {
	plugin::save_object();

	/* Save base, since this is no LDAP attribute */
	if (isset($_POST['base']) && chkacl($this->acl, "create") == ""){
		$this->base= $_POST['base'];
	}
  }


  /* Check values */
  function check()
  {
	$message= array();

	/* Permissions for that base? */
	$new_dn= utf8_encode("ou=$this->ou,".$this->config->departments[$this->base]);
	$acl= get_permissions ($new_dn, $this->ui->subtreeACL);
	$acl= get_module_permission($acl, "department", $this->dn);
	if (chkacl($acl, "create") != ""){
		$message[]= _("You have no permissions to create a department on this 'Base'.");
	}

	/* Check for presence of this department */
	$ldap= $this->config->get_ldap_link();
	$attrs= $ldap->cat ("ou=".$this->ou.",".$this->config->departments[$this->base]);
	if (!($attrs === FALSE)){
		$message[]= _("Department with 'Name' already exists.");
	}

	/* All required fields are set? */
	if ($_POST["ou"] == ""){
		$message[]= _("Required field 'Name' is not set.");
	}
	if ($_POST["description"] == ""){
		$message[]= _("Required field 'Description' is not set.");
	}

	/* Validate and modify - or: spaghetti rules! */
	if ($_POST['ou'] == "incoming"){
		$message[]= _("The field 'Name' contains the reserved word 'incoming'.".
				" Please choose another name.");
	}
	if (preg_match ('/[,#+:=>\\\\]/', $_POST['ou'])){
		$message[]= _("The field 'Name' contains invalid characters.");
	}
	if (!is_phone_nr($_POST['telephoneNumber'])){
		$message[]= _("The field 'Phone' contains an invalid phone number.");
	}
	if (!is_phone_nr($_POST['facsimileTelephoneNumber'])){
		$message[]= _("The field 'Fax' contains an invalid phone number.");
	}

	return $message;
  }


  /* Save to LDAP */
  function save()
  {
	plugin::save();

	/* Write back to ldap */
	$ldap= $this->config->get_ldap_link();
	$ldap->cat($this->dn);
	$a= $ldap->fetch();
	$ldap->cd($this->dn);
	if (count($a)){
		$ldap->modify($this->attrs);
	} else {
		$ldap->add($this->attrs);
	}
	show_ldap_error($ldap->error);

	/* Create basic structures */
	if (!count($a)){
		foreach (array("people", "groups", "systems", "apps", "configs,ou=systems",
			"terminals,ou=systems", "servers,ou=systems", "gofax,ou=systems") as $dir){

			$ldap->cd ("ou=$dir,".$this->dn);
			$attrs= array();
			$attrs['objectClass'][]= "organizationalUnit";
			$attrs['ou'][]= preg_replace ("/,.*$/", "", $dir);
			$ldap->add ($attrs);

			show_ldap_error($ldap->error);
		}
	}

	/* Optionally execute a command after we're done */
	$this->postcreate();
  }

}

?>
