<?php
class terminfo extends plugin
{
  /* Generic terminal attributes */
  var $ghCpuType= "-";
  var $ghMemSize= "-";
  var $macAddress= "-";
  var $ghUsbSupport= "-";
  var $ghNetNic= array();
  var $ghIdeDev= array();
  var $ghScsiDev= array();
  var $ghGfxAdapter= "-";
  var $ghSoundAdapter= "-";
  var $gotoLastUser= "-";

  /* Needed values and lists */
  var $base= "";
  var $cn= "";

  /* Plugin side filled */
  var $modes= array("disabled", "thin", "rescue");


  /* attribute list for save action */
  var $attributes= array("cn", "gotoMode", "gotoTerminalPath",
			"gotoSwapServer", "gotoSyslogServer", "gotoNtpServer",
			"ghCpuType", "ghMemSize", "macAddress", "ghUsbSupport",
			"ghGfxAdapter", "ghSoundAdapter", "gotoLastUser");
  var $objectclasses= array("gotoTerminal", "goHard");

  function terminfo ($config, $dn= NULL)
  {
	plugin::plugin ($config, $dn);

	/* Read arrays */
	foreach (array("ghNetNic", "ghIdeDev", "ghScsiDev") as $val){
		if (!isset($this->attrs[$val])){
			continue;
		}
		for ($i= 0; $i<$this->attrs[$val]['count']; $i++){
			array_push($this->$val, $this->attrs[$val][$i]);
		}
	}
  }

  function execute()
  {
	/* Do we need to flip is_account state? */
	if (isset($_POST['modify_state'])){
		$this->is_account= !$this->is_account;
	}

	/* Do we represent a valid terminal? */
	if (!$this->is_account && $this->parent == NULL){
		echo "<img src=\"images/stop.png\" align=center>&nbsp;<b>".
		_("This 'dn' has no terminal features.")."</b>";
		return;
	}

	/* Check if terminal is online */
	$query= "fping -q -r 1 -t 500 ".$this->cn;
	exec ($query, $dummy, $retval);
	if ($retval == 0){
		$status= _("online");
	} else {
		$status= _("offline");
	}

	/* Show main page */
	require ("info.inc");
  }

  function remove_from_parent()
  {
	$ldap= $this->config->get_ldap_link();
	$ldap->rmdir($this->dn);
	show_ldap_error($ldap->error);
  }


  /* Save data to object */
  function save_object()
  {
	plugin::save_object();
  }



  /* Save to LDAP */
  function save()
  {
  }

}

?>
