<?php
class blocklist extends plugin
{
  /* blocklist attributes */
  var $cn= "";
  var $description= "";
  var $type= "";
  var $goFaxBlocklist= array();
  var $base= "";

  /* Headpage attributes */
  var $last_block_sorting= "invalid";
  var $blocklists= array();

  /* attribute list for save action */
  var $attributes= array("cn", "description");
  var $objectclasses= array();

  function blocklist ($config, $ui)
  {
	$this->ui= $ui;
	$this->dn= "";
	$this->config= $config;
  }

  function execute()
  {
	/* Create new blocklist? */
	if (isset($_POST['new_blocklist'])){
		$this->clear_fields();
		$this->acl= "#all#";
		$this->dn= "new";
		plugin::plugin ($this->config, $this->dn);
	}

	/* Edit selected blocklist? */
	if (isset($_POST['select_blocklist']) && isset($_POST['blocklist']) != ""){
		$this->clear_fields();
		$this->dn= $_POST['blocklist'];
		$this->acl= get_permissions ($this->dn, $this->ui->subtreeACL);
		$this->acl= get_module_permission($this->acl, "blocklists", $this->dn);
		plugin::plugin ($this->config, $this->dn);

		/* Load missing lists */
		if (isset($this->attrs["goFaxSBlocklist"])){
			for ($i= 0; $i<$this->attrs["goFaxSBlocklist"]["count"]; $i++){
				$this->goFaxBlocklist[]= $this->attrs["goFaxSBlocklist"][$i];
			}
			$this->type= 0;
		} elseif (isset($this->attrs["goFaxRBlocklist"])){
			for ($i= 0; $i<$this->attrs["goFaxRBlocklist"]["count"]; $i++){
				$this->goFaxBlocklist[]= $this->attrs["goFaxRBlocklist"][$i];
			}
			$this->type= 1;
		}
	}

	/* Delete blocklist requested */
	if (isset($_POST['delete_blocklist']) && isset($_POST['blocklist'])){
		$this->dn= $_POST['blocklist'];

		/* Check locking */
		if (($user= get_lock($this->dn)) != ""){
			$_SESSION['dn']= $this->dn;
			gen_locked_message($user, $this->dn);
			return;
		} else {
			# Lock this dn for editing
			add_lock ($this->dn, $this->ui->dn);

			@require_once ("remove.inc");
			return;
		}
	}

	/* Finally delete blocklist */
	if (isset($_POST['delete_blocklist_confirm'])){
		$acl= get_permissions ($this->dn, $this->ui->subtreeACL);
		$acl= get_module_permission($acl, "blocklists", $this->dn);
		if (chkacl($acl, "all") == ""){
			$this->remove_from_parent();
			$this->reload ();
		} else {
			print_red ("You have no permission to remove this blocklist.<br>");
		}
	}

	/* Cancel dialog */
	if (isset($_POST['edit_cancel']) || isset($_POST['delete_blocklist_cancel']) ||
		isset($_POST['delete_blocklist_confirm']) || isset($_POST['delete_lock'])){

		del_lock ($this->dn);
		$this->clear_fields();
	}

	/* Handle interactions: add */
	if (isset($_POST['add_number']) && $_POST['number'] != ""){
		if (is_phone_nr($_POST['number'])){
			$this->addNumber ($_POST['number']);
		} else {
			print_red (_("Please specify a valid phone number."));
		}
	}

	/* Handle interactions: delete */
	if (isset($_POST['delete_number']) && count($_POST['numbers']) > 0){
		$this->delNumber ($_POST['numbers']);
	}

	/* What about finish? */
	if (isset($_POST['edit_finish'])){
		$message= $this->check();

		/* No errors, save object */
		if (count ($message) == 0){

			/* Perpare 'dn' in case of new entries */
			if ($this->dn == "new"){
				$this->dn= "cn=$this->cn,ou=gofax,ou=systems,".
					$this->config->departments[$this->base];
			}

			$this->save ();
			$this->acl= "#none#";
			$this->dn= "";
			del_lock ($this->ui->dn);
		} else {
			/* Errors found, show message */
			show_errors ($message);
		}
	}
	
	/* Headpage or normal plugin screen? */
	if ($this->dn == ""){
		/* Check sorting variable */
		$this->check_sortranges();
		$this->reload();

		/* Show main page */
		require ("headpage.inc");
		return;
	}


	/* Show main page */
	require ("edit.inc");
  }

  function clear_fields()
  {
	$this->dn= "";
	$this->description= "";
	$this->cn= "";
	$this->base= "";
	$this->goFaxBlocklist= array();
	$this->acl= "#none#";
  }

  function reload()
  {
	/* Generate blocklists */
	$res= get_list($this->ui->subtreeACL, "(|(objectClass=goFaxSBlock)(objectClass=goFaxRBlock))");
	$this->last_block_sorting= "invalid";

	$this->blocklists= array();
	foreach ($res as $value){
		if (preg_match ($this->sortranges[$this->sorting], $value["cn"][0])){
			$this->blocklists[$value["dn"]]= $value["cn"][0];
			if (isset($value["description"][0])){
				$this->blocklists[$value["dn"]]= $value["cn"][0]." (".
							utf8_decode($value["description"][0]).")";
			}
		}
	}
	natcasesort ($this->blocklists);
	reset ($this->blocklists);
  }

  function remove_from_parent()
  {
	$ldap= $this->config->get_ldap_link();
	$ldap->rmDir($this->dn);
  }


  /* Save data to object */
  function save_object()
  {
	plugin::save_object();
	
	/* Save type, needed to detect objectClass */
	if (isset($_POST['type']) && chkacl($this->acl, "cn") == ""){
		$this->type= $_POST['type'];
	}

        /* Save base, since this is no LDAP attribute */
        if (isset($_POST['base']) && chkacl($this->acl, "create") == ""){
                $this->base= $_POST['base'];
        }
  }


  /* Check values */
  function check()
  {
	$message= array();

	/* Permissions for that base? */
	if ($this->base != ""){
		$new_dn= utf8_encode("cn=".$this->cn.",ou=gofax,ou=systems,").
				$this->config->departments[$this->base];
	} else {
		$new_dn= $this->dn;
	}

	$ui= get_userinfo();
	$acl= get_permissions ($new_dn, $ui->subtreeACL);
	$acl= get_module_permission($acl, "blocklist", $new_dn);
	if (chkacl($acl, "create") != ""){
		$message[]= _("You have no permissions to create a blocklist on this 'Base'.");
	}


	/* check syntax: must cn */
	if ($this->cn == ""){
		$message[]= _("Required field 'Name' is not set.");
	} else {
		if (!is_uid($this->cn)){
			$message[]= _("Required field 'Name' contains invalid characters");
		}
		if ($this->dn == 'new'){
			$ldap= $this->config->get_ldap_link();
			$ldap->cd ("ou=gofax,ou=systems,".$this->config->current["BASE"]);
			$ldap->search ("(&(|(objectClass=goFaxSBlock)(objectClass=goFaxRBlock))".
					"(cn=".$this->cn."))");
			if ($ldap->count() != 0){
				$message[]= _("Specified name is already used.");
			}
		}
	}

	/* Is user allowed to create in 'base'? */
	if (chkacl($this->acl, "create") != ""){
		$message[]= _("No permission to create a blocklist on this base.");
	}

	return $message;
  }


  /* Save to LDAP */
  function save()
  {
	plugin::save();

	/* Type selection */
	if ($this->type == 0){
		$type= "goFaxSBlock";
	} else {
		$type= "goFaxRBlock";
	}

	/* Add list */
	$this->attrs['objectClass']= $type;
	if (count($this->goFaxBlocklist)){
		$this->attrs["$type"."list"]= $this->goFaxBlocklist;
	}

	/* Write back to ldap */
	$ldap= $this->config->get_ldap_link();
	$ldap->cd($ldap->getParentDir($this->dn));
	$ldap->search("cn=$this->cn");
	$a= $ldap->fetch();
	$ldap->cd($this->dn);
	if (count($a)){
		$ldap->modify($this->attrs);
	} else {
		$ldap->add($this->attrs);
	}
	show_ldap_error($ldap->error);
  }


  function addNumber($number)
  {
	if (!in_array($number, $this->goFaxBlocklist)){
		$this->goFaxBlocklist[]= $number;
		sort($this->goFaxBlocklist);
	}
  }

  function delNumber($numbers)
  {
	$tmp= array();
	foreach ($this->goFaxBlocklist as $val){
		if (!in_array($val, $numbers)){
			$tmp[]= $val;
		}
	}
	$this->goFaxBlocklist= $tmp;
  }


}

?>
