<?php

class faxreport extends plugin
{
  /* For internal use */
  var $start= 0;
  var $search_for= "*";
  var $search_base= "";
  var $year= "";
  var $month= "";
  var $sort= 0;
  var $report_list= array();
  var $userfilter= "";
  var $ui= NULL;

  /* Constant stuff */
  var $status= array( "SENT", "MAILED", "SERROR", "RERROR", "SBLOCK", "RBLOCK",
			"DELETED", "REQUEUED", "DISABLED", "PRINTED", "DIVERTED",
			"UNDEFINED", "UNDEFINED", "UNDEFINED", "UNDEFINED",
			"UNDEFINED");
  var $fields= array("uid", "queuing_time", "status", "sender_id", "receiver_id", "pages");

  /* attribute list for save action */
  var $attributes= array();
  var $objectclasses= array();

  function faxreport ($config, $ui)
  {
	/* Include config object */
	$this->config= $config;
	$this->ui= $ui;

	/* Try to get matching search base for user provided
	   by 'dn' */
	$tmp= preg_replace ("/^[^,]+,[^,]+,/", "", $ui->dn);
	$sb= array_search($tmp, $this->config->departments);
	if ($sb === FALSE){
		$sb= "/";
	}
	$this->search_base= $sb;

	/* Preset date representation */
	$this->year= date("Y");
	$this->month= date("m");
  }

  function execute()
  {
	/* Adapt sorting */
	if (isset($_GET['sort'])){
		$this->sort= (int)$_GET['sort'];
		if ($this->sort < 0 || $this->sort > 5){
			$this->sort= 0;
		}
	}

	/* Do detail view? */
	if (isset($_GET['detail'])){
		$query = "SELECT id,uid,queuing_time,status,sender_id,sender_msn,receiver_id,".
			"receiver_msn,pages,status_message,transfer_time FROM faxlog ".
			"WHERE id=".$_GET['detail'].";";

		/* Connecting, selecting database */
		$cfg= $this->config->data['SERVERS']['FAX'];
		$link = mysql_connect($cfg['SERVER'], $cfg['LOGIN'], $cfg['PASSWORD'])
			or printe("fax reports", "Could not connect to database server!");
		mysql_select_db("gofax")
			or printe("fax reports", "Could not select database!");

		@DEBUG (DEBUG_MYSQL, __LINE__, __FUNCTION__, __FILE__,
			$query, "Database query");
		$result = mysql_query($query) or printe("fax reports", "Database query failed!");

		$line = mysql_fetch_array($result, MYSQL_ASSOC);
		mysql_close($link);

		if (!preg_match ("/'".$line["uid"]."'/", $this->userfilter)){
			printe ("fax report", "No permissions for this fax id!");
		}

		$parts= array( "id", "uid", "queuing_time", "status", "sender_id", "sender_msn",
			"receiver_id", "receiver_msn", "pages", "status_message", "transfer_time" );
		foreach ($parts as $vname) {
			$final="fax_$vname";
			$$final= $line[$vname];
		}

		$_SESSION['userfilter']= $this->userfilter;
		require_once ("detail.inc");
		return;
	}


	/* Check for interaction */
	if ($_SERVER["REQUEST_METHOD"] == "POST"){

		/* Save formular information */
		$this->save_objects();

		/* Search button has been pressed */
		if (isset($_POST['search']) && $_POST['search_for'] != ""){
			$this->start= 0;

			if (is_integer (strpos($this->search_for, "*"))){
				$s= $this->search_for;
			} else {
				$s= "*".$this->search_for."*";
			}
			$ldap= $this->config->get_ldap_link();
			$ldap->cd ($this->config->departments[$this->search_base]);

			/* Perform ldap search for potential users */
			$ldap->search ("(&(objectClass=gosaAccount)(!(objectClass=gosaUserTemplate))".
				"(objectClass=goFaxAccount)".
				"(|(uid=$s)(l=$s)(homePhone=$s)".
				"(telephoneNumber=$s)(facsimileTelephoneNumber=$s)(mobile=$s)".
				"(pager=$s)(cn=$s)(givenName=$s)(sn=$s)(personalTitle=$s)".
				"(title=$s)))");

			$fax_users= array();
			while ($attrs= $ldap->fetch()){
				$acl= get_permissions ($ldap->getDN(), $this->ui->subtreeACL);
				$acl= get_module_permission($acl, "fax", $ldap->getDN());

				if (chkacl ($acl, "faxReport") == ""){
					$fax_users[]= $attrs["uid"][0];
				}
			}

			/* Prepare SQL query */
			$this->userfilter= "";
			foreach ($fax_users as $user){
				$this->userfilter.= "uid = '$user' OR ";
			}
			$this->userfilter= preg_replace("/OR $/", "", $this->userfilter);
		}

	}

	/* Perform SQL query */
	if ($this->userfilter){
		$start= date ("YmdHis", mktime(0,0,0,$this->month,1,$this->year));
		$end=   date ("YmdHis", mktime(0,0,0,$this->month+1,0,$this->year));
		$query = "SELECT id,uid,queuing_time,status,sender_id,receiver_id,pages FROM faxlog ".
			"WHERE ( ".$this->userfilter." ) AND queuing_time <= $end AND ".
			"queuing_time >= $start ORDER BY ".$this->fields[$this->sort].";";

		/* Connecting, selecting database */
		$cfg= $this->config->data['SERVERS']['FAX'];
		$link = mysql_connect($cfg['SERVER'], $cfg['LOGIN'], $cfg['PASSWORD'])
			or printe("fax reports", "Could not connect to database server!");

		mysql_select_db("gofax") or printe("fax reports", "Could not select database!");

		@DEBUG (DEBUG_MYSQL, __LINE__, __FUNCTION__, __FILE__,
			$query, "Database query");
		$result = mysql_query($query) or printe("fax reports", "Database query failed!");

		$report_list= array();
		while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
			$day=   substr($line["queuing_time"], 6, 2);
			$month= substr($line["queuing_time"], 4, 2);
			$year=  substr($line["queuing_time"], 0, 4);
			$hour=  substr($line["queuing_time"], 8, 2);
			$minute=substr($line["queuing_time"], 10, 2);

			$report_list[]= "<td><a href=\"main.php?plug=".$_GET['plug']."&detail=".
				$line["id"]."\">".$line["uid"]."</a></td>".
				"<td>$day.$month.$year $hour:$minute</td>".
				"<td>".$this->status[$line["status"]]."</td>".
				"<td>".$line["sender_id"]."</td>".
				"<td>".$line["receiver_id"]."</td>".
				"<td>".$line["pages"]."</td>";
		}

		$this->report_list= $report_list;
		mysql_close($link);
	}


	/* Show main page */
	require ("edit.inc");
  }

  function save_objects()
  {
	$this->search_base= $_POST['search_base'];
        $this->search_for= $_POST['search_for'];
        $this->year= $_POST['year'];
        $this->month= $_POST['month'];
  }

}

?>
