<div class="plugtop">
  <img src="images/email.png" align=center>&nbsp;<?php echo _("User mail settings");?>
</div>

<?php

	/* Reset requested? */
	if (isset($_POST['edit_cancel']) || 
		(isset($_GET['reset']) && $_GET['reset'] == 1)){
		del_lock ($ui->dn);
		sess_del ('edit');
		sess_del ('mailAccount');
	}

	/* Create mail object on demand */
	if (!isset($_SESSION['mailAccount']) || (isset($_GET['reset']) && $_GET['reset'] == 1)){
		$_SESSION['mailAccount']= new mailAccount ($config, $ui->dn);
	}
	$mailAccount= $_SESSION['mailAccount'];

	/* save changes back to object */
	if (isset ($_SESSION['edit'])){
		$mailAccount->save_object ();
	}

	/* Enter edit mode? */
	if (isset($_POST['edit'])){

		/* Check locking */
		if (($username= get_lock($ui->dn)) != ""){
			$_SESSION['back_plugin']= $plug;
			gen_locked_message ($username, $ui->dn);
			exit ();
		}

		/* Lock the current entry */
		add_lock ($ui->dn, $ui->dn);
		$_SESSION['dn']= $ui->dn;
		$_SESSION['edit']= TRUE;
	}

	/* Adjust acl's to mode */
	if (isset($_SESSION['edit'])){
		$acl= get_permissions ($ui->dn, $ui->subtreeACL);
		$mailAccount->acl= get_module_permission($acl, "mail", $ui->dn);
	} else {
		$mailAccount->acl= "#none#";
	}

	/* save changes to LDAP and disable edit mode */
	if (isset($_POST['edit_finish'])){

		/* Perform checks */
		$message= $mailAccount->check ();

		/* No errors, save object */
		if (count ($message) == 0){
			$mailAccount->save ();
			$mailAccount->acl= "#none#";
			del_lock ($ui->dn);
			sess_del ('edit');

		} else {
			/* Errors found, show message */
			show_errors ($message);
		}
	}

	/* Execute formular */
	$mailAccount->execute ();

	/* Store changes  in session */
	if (isset ($_SESSION['edit'])){
		$_SESSION['mailAccount']= $mailAccount;
	}

	/* Show page footer depending on the mode */
	if (!$mailAccount->forward_dialog && $mailAccount->is_account){
?>

<p class="plugbottom">

<?php
/* Are we in edit mode? */
  if (isset($_SESSION['edit'])){
?>

  <input type=submit name="edit_finish" value="<?php echo _("Finish");?>">
  &nbsp;
  <input type=submit name="edit_cancel" value="<?php echo _("Cancel");?>">

<?php
  } else {
?>

  <input type=submit name="edit" value="<?php echo _("Edit");?>">

<?php
  }
?>
</p>
<?php
}
?>
