<?php
class proxyAccount extends plugin
{
  /* Proxy attributes */
  var $gosaProxyAcctFlags= "[N    ]";
  var $gosaProxyID= "";
  var $gosaProxyWorkingStart= 420;
  var $gosaProxyWorkingStop= 1020;

  /* attribute list for save action */
  var $attributes= array("gosaProxyID", "gosaProxyAcctFlags", "gosaProxyWorkingStart",
			"gosaProxyWorkingStop");
  var $objectclasses= array("gosaProxyAccount");

  function proxyAccount ($config, $dn= NULL)
  {
	plugin::plugin ($config, $dn);
  }

  function execute()
  {
	/* Do we need to flip is_account state? */
	if (isset($_POST['modify_state'])){
		$this->is_account= !$this->is_account;
	}

	/* Do we represent a valid account? */
	if (!$this->is_account && $this->parent == NULL){
		echo "<img src=\"images/stop.png\" align=center>&nbsp;<b>".
		_("This 'dn' has no proxy extensions.")."</b>";
		return;
	}

	/* Show tab dialog headers */
	if ($this->parent != NULL){
		if ($this->is_account){
			$this->show_header(_("Remove proxy account"),
				_("This account has proxy features enabled. ".
				  "You can disable them by clicking below."));
		} else {
			$this->show_header(_("Create proxy account"),
				  _("This account has proxy features disabled. ".
				  "You can enable them by clicking below."));
			return;
		}
	}

	/* Show main page */
	require ("edit.inc");
  }

  function remove_from_parent()
  {
	plugin::remove_from_parent();
	
	$ldap= $this->config->get_ldap_link();
        @DEBUG (DEBUG_LDAP, __LINE__, __FUNCTION__, __FILE__,
                $this->attributes, "Save");
	$ldap->cd($this->dn);
	$ldap->modify($this->attrs);
	show_ldap_error($ldap->error);

	/* Optionally execute a command after we're done */
	$this->postremove();
  }


  /* Save data to object */
  function save_object()
  {
	if (isset($_POST['proxyTab'])){
		/* Save flag value */
		if (chkacl ($this->acl, "gosaProxyAcctFlags") == ""){
			if (isset($_POST["filter"])){
				$this->gosaProxyAcctFlags= "[".$_POST["filter"]."          ]";
			}
		}

		/* Save time values */
		if (chkacl ($this->acl, "gosaProxyWorkingTime") == "" && isset($_POST['startMinute'])){
			$this->gosaProxyWorkingStart= $_POST["startHour"] * 60 + $_POST["startMinute"];
			$this->gosaProxyWorkingStop = $_POST["stopHour"]  * 60 + $_POST["stopMinute"];
		}
	}
  }


  /* Save to LDAP */
  function save()
  {
	plugin::save();

	/* Write back to ldap */
	$ldap= $this->config->get_ldap_link();
	$ldap->cd($this->dn);
	$ldap->modify($this->attrs);
	show_ldap_error($ldap->error);

	/* Optionally execute a command after we're done */
	$this->postcreate();
  }

}

?>
