<?php
        /* Show page header */
?>

<div class="plugtop">
	<img src="images/proxy.png" align=center>&nbsp;<?php echo _("Proxy settings");?>
</div>

<?php

	/* Reset requested? */
	if (isset($_POST['edit_cancel']) ||
		(isset($_GET['reset']) && $_GET['reset'] == 1)){

		del_lock ($ui->dn);
		sess_del ('edit');
		sess_del ('proxyAccount');
	}

	/* Create proxyAccount object on demand */
	if (!isset($_SESSION['proxyAccount']) || (isset($_GET['reset']) && $_GET['reset'] == 1)){
		$_SESSION['proxyAccount']= new proxyAccount ($config, $ui->dn);
	}
	$proxyAccount= $_SESSION['proxyAccount'];

	/* save changes back to object */
	if (isset ($_SESSION['edit'])){
		$proxyAccount->save_object ();
	}

	/* Enter edit mode? */
	if (isset($_POST['edit'])){

		/* Check locking */
		if (($username= get_lock($ui->dn)) != ""){
			$_SESSION['back_plugin']= $plug;
			gen_locked_message ($username, $ui->dn);
			exit ();
		}

		/* Lock the current entry */
		add_lock ($ui->dn, $ui->dn);
		$_SESSION['dn']= $ui->dn;
		$_SESSION['edit']= TRUE;
	}

	/* Adjust acl's to mode */
	if (isset($_SESSION['edit'])){
		$acl= get_permissions ($ui->dn, $ui->subtreeACL);
		$proxyAccount->acl= get_module_permission($acl, "proxy", $ui->dn);
	} else {
		$proxyAccount->acl= "#none#";
	}

	/* save changes to LDAP and disable edit mode */
	if (isset($_POST['edit_finish'])){

                /* Perform checks */
                $message= $proxyAccount->check ();

                /* No errors, save object */
                if (count ($message) == 0){
                        $proxyAccount->save ();
                        $proxyAccount->acl= "#none#";
                        del_lock ($ui->dn);
                        sess_del ('edit');

			/* Reload */
			$proxyAccount= new proxyAccount ($config, $ui->dn);
                } else {
                        /* Errors found, show message */
                        show_errors ($message);
                }
        }

	/* Execute formular */
	$proxyAccount->execute ();

	/* Store changes  in session */
	if (isset ($_SESSION['edit'])){
		$_SESSION['proxyAccount']= $proxyAccount;
	}

	if ($proxyAccount->is_account){
?>

<p class="plugbottom">

<?php
/* Are we in edit mode? */
  if (isset($_SESSION['edit'])){
?>

  <input type=submit name="edit_finish" value="<?php echo _("Finish");?>">
  &nbsp;
  <input type=submit name="edit_cancel" value="<?php echo _("Cancel");?>">

<?php
  } else {
?>

  <input type=submit name="edit" value="<?php echo _("Edit");?>">

<?php
  }
}
?>
</p>
