<?php
	/* Show page header */
?>

<div class="plugtop">
  <img src="images/personal.png" align=center>&nbsp;<?php echo _("Generic user information");?>
</div>

<?php
	/* Reset requested? */
	if (isset($_POST['edit_cancel']) || 
		(isset($_GET['reset']) && $_GET['reset'] == 1)){
		del_lock ($ui->dn);
		sess_del ('edit');
		sess_del ('user');
	}

	/* Create user object on demand */
	if (!isset($_SESSION['user']) || (isset($_GET['reset']) && $_GET['reset'] == 1)){
		$_SESSION['user']= new user ($config, $ui->dn);
	}
	$user= $_SESSION['user'];

	/* save changes back to object */
	if (isset ($_SESSION['edit'])){
		$user->save_object ();
	}

	/* Enter edit mode? */
	if (isset($_POST['edit'])){

		/* Check locking */
		if (($username= get_lock($ui->dn)) != ""){
			$_SESSION['back_plugin']= $plug;
			gen_locked_message ($username, $ui->dn);
			exit ();
		}

		/* Lock the current entry */
		add_lock ($ui->dn, $ui->dn);
		$_SESSION['dn']= $ui->dn;
		$_SESSION['edit']= TRUE;
	}

	/* Adjust acl's to mode */
	if (isset($_SESSION['edit'])){
		$acl= get_permissions ($ui->dn, $ui->subtreeACL);
		$user->acl= get_module_permission($acl, "user", $ui->dn);
	} else {
		$user->acl= "#none#";
	}

	/* save changes to LDAP and disable edit mode */
	if (isset($_POST['edit_finish'])){

		/* Perform checks */
		$message= $user->check ();

		/* No errors, save object */
		if (count ($message) == 0){
			$user->save ();
			$user->acl= "#none#";
			del_lock ($ui->dn);
			sess_del ('edit');

		} else {
			/* Errors found, show message */
			show_errors ($message);
		}
	}

	/* Execute formular */
	$user->execute ();

	/* Store changes  in session */
	if (isset ($_SESSION['edit'])){
		$_SESSION['user']= $user;
	}

	/* Show page footer depending on the mode */
	if (!$user->cert_dialog && !$user->picture_dialog && $user->is_account){
?>

<p class="plugbottom">

<?php
/* Are we in edit mode? */
  if (isset($_SESSION['edit'])){
?>

  <input type=submit name="edit_finish" value="<?php echo _("Finish");?>">
  &nbsp;
  <input type=submit name="edit_cancel" value="<?php echo _("Cancel");?>">

<?php
  } else {

	/* 'viewid' may be set by i.e. the phonelist plugin. This
	   means that we want to go back... */
	if (isset ($viewid)){
		$str= _("Back");
		$fn = "back";
	} else {
		$str= _("Edit");
		$fn = "edit";
	}
?>

  <input type=submit name="<?php echo $fn;?>" value="<?php echo $str;?>">

<?php
  }
?>
</p>
<?php
}
?>
